var uniqueChars = [];

var Languages = function () {
    if (Languages.instance != null) {
        return Languages.instance;
    }

    Languages.instance = this;

    this.gameTextsParsed = null;
    this.xml = null;
    this.gameTextsLists = [];

    var file = game.cache.getText('lang_strings');
    var data = JSON.parse(file)["stringresources"]["strings"]["string"];

    for (var i = 0; i < data.length; i++) {
        if (this.gameTextsLists[data[i].id] == null) {
            this.gameTextsLists[data[i].id] = [];
        }

        for (var j = 0; j < LANGUAGES.length; j++) {
            if (data[i][LANGUAGES[j]].length > 0) {
                this.gameTextsLists[data[i].id][LANGUAGES[j]] = data[i][LANGUAGES[j]].replace(/\\n/g, '\n');

                if (LANGUAGES[j] != 'ru')
                    extractUniqueChars(this.gameTextsLists[data[i].id][LANGUAGES[j]], uniqueChars);
            }

            if (LANGUAGES[j] == 'no')
                extractUniqueChars(this.gameTextsLists[document.item(i).getAttribute("id")][LANGUAGES[j]], uniqueChars);
        }
    }

    uniqueChars.sort();
    // console.log("POCET ZNAKOV: ", uniqueChars.length);
    // LOG(uniqueChars.join(""));
};

var LANGUAGES = ["en", "de", "es", "fr", "it", "pt", "nl", "ru"];

Languages.instance = null;

Languages.prototype = {};

function STR(id) {
    if (Languages.instance.gameTextsLists[id] == undefined || Languages.instance.gameTextsLists[id][Languages.instance.language] == undefined) {
        console.log(id);
        LOG('STR(' + id + ') MISSING!')
        return "NAN";
    }

    var retVal = Languages.instance.gameTextsLists[id][Languages.instance.language];
    return retVal.replaceAll('\\n', '\n');
}

function extractUniqueChars(string, chars) {
    for (var i = 0; i < string.length; i++) {
        if (chars.indexOf(string[i]) < 0)
            chars.push(string[i]);
    }
}