
var SceneAchievementPopup = function()
{
    SceneAchievementPopup.instance = this;

    this.create();
};

SceneAchievementPopup.instance = null;

SceneAchievementPopup.prototype = {

    create: function ()
    {
        grpAchievementPopup = game.add.group();
        grpAchievementPopup.name = "grpAchievementPopup";
        this.grpScene = grpAchievementPopup;
        
        imgAchievementPopupOverlay = game.add.sprite(game.width >> 1, game.height >> 1, 'pak1', 'blank');
        imgAchievementPopupOverlay.anchor.setTo(0.5);
        imgAchievementPopupOverlay.tint = 0x354854;
        imgAchievementPopupOverlay.alpha = 0.7;
        imgAchievementPopupOverlay.inputEnabled = true;
        grpAchievementPopup.addChild(imgAchievementPopupOverlay);

        imgAchievementPopupBar = game.add.sprite(game.width >> 1, 0, 'pak1', GetSelectedThemeAchievementBar());
        imgAchievementPopupBar.anchor.setTo(0.5, 0.5);
        grpAchievementPopup.addChild(imgAchievementPopupBar);

        imgAchievementPopupBarAnchor = game.add.sprite(0, 0, 'pak1', 'void');
        imgAchievementPopupBarAnchor.anchor.setTo(0.5, 0.5);
        imgAchievementPopupBar.addChild(imgAchievementPopupBarAnchor);

        txtAchievementPopupUnlocked = gameState.CreateText(0, -imgAchievementPopupBar.height / 6, 'gamefont', STR('ACHIEVEMENT_UNLOCKED'), 25 * game.width / 680);
        txtAchievementPopupUnlocked.anchor.setTo(0.5, 1);
        // txtAchievementPopupUnlocked.alpha = 0.7;
        txtAchievementPopupUnlocked.tint = 0x000000;
        imgAchievementPopupBarAnchor.addChild(txtAchievementPopupUnlocked);

        txtAchievementPopupTitle = gameState.CreateText(0, imgAchievementPopupBar.height / 10, 'gamefont', STR('ACHIEVEMENT_11_HELP_TITLE'), 35 * game.width / 680);
        txtAchievementPopupTitle.STR = 'ACHIEVEMENT_11_HELP_TITLE';
        txtAchievementPopupTitle.anchor.setTo(0.5, 0.5);
        txtAchievementPopupTitle.tint = 0x000000;
        imgAchievementPopupBarAnchor.addChild(txtAchievementPopupTitle);


        grpAchievementPopup.visible = false;
    },

    onResolutionChange: function()
    {
        imgAchievementPopupOverlay.width = game.width * 1.1;
        imgAchievementPopupOverlay.height = game.height * 1.1;
        imgAchievementPopupOverlay.position.set(game.width >> 1, game.height >> 1)

        var itemH = game.height / 8;

        imgAchievementPopupBar.frameName = GetSelectedThemeAchievementBar();
        imgAchievementPopupBar.width = game.width * 1.1;
        imgAchievementPopupBar.height = itemH;
        imgAchievementPopupBar.position.setTo(game.width >> 1, game.height - ingameButtons[0].height * 2.5);
        if(grpSceneGameOver.visible)
            imgAchievementPopupBar.position.setTo(game.width >> 1, (game.height >> 1) - imgAchievementPopupBar.height * 0.7);

        imgAchievementPopupBarAnchor.scale.setTo(1 / imgAchievementPopupBar.scale.x, 1 / imgAchievementPopupBar.scale.y);

        txtAchievementPopupUnlocked.y = -imgAchievementPopupBar.height / 6;
        txtAchievementPopupTitle.y = imgAchievementPopupBar.height / 10;
    },

    update: function()
    {
    },

    updateTexts: function()
    {
        txtAchievementPopupUnlocked.text = STR('ACHIEVEMENT_UNLOCKED').toUpperCase();
        txtAchievementPopupTitle.text = STR(txtAchievementPopupTitle.STR);
    },

    ShowAnimated: function ()
    {
    },

    HideAnimated: function ()
    {
    }

}