/**
 * Created by echovanec on 10. 12. 2014.
 */

/** @constructor */
var Preloader = function (game) {
}
var loaderPosY;
var preloadState;

Preloader.prototype = {

    preload: function () {

        sceneLanguages = null;
        startTime = Date.now();

        this.game.stage.backgroundColor = 0x000000;
        preloadState = this;

        loaderPosY = this.game.world.height / 5 * 4.5;

        var logoImg = "inlogic_logo";

        //PPS_USE-CLOUDGAMES
        /*
        logoImg = "cloudApiImg";
        //PPS_USE-CLOUDGAMES
        */

        imgSplash = this.game.add.sprite(game.width / 2, game.height / 2, logoImg);
        //PPS_USE-REMOVE_INIT_INLLOGO
        /*
        imgSplash.loadTexture('sol_logo');
        imgSplash.scale.set(0.7);
        //PPS_USE-REMOVE_INIT_INLLOGO
        */
        imgSplash.anchor.x = 0.5;
        imgSplash.anchor.y = 0.5;
        //PPS_USE-CLOUDGAMES
        /*
        imgSplash.scale.set(0.65);
        imgSplash.inputEnabled = true;
        imgSplash.events.onInputDown.add(cloudGames_logo_link);
        // PPS_USE-CLOUDGAMES
        */
        //imgSplash.width = game.width;
        //imgSplash.scale.y = imgSplash.scale.x;

        imgBtn = this.game.add.sprite(game.width / 2, game.height / 2, 'void');
        imgBtn.anchor.set(0.5);
        imgBtn.scale.x = (game.width / 100) + 0.2;
        imgBtn.scale.y = (game.height / 100) + 0.2;

        new Languages();

        percentageText = this.game.add.text(this.game.world.centerX, this.game.height - game.width * 0.03, "0 %", {
            font: '40px "Arial Black"',
            fill: '#FFFFFF'
        });
        percentageText.anchor.set(0.5);
        percentageText.scale.set(game.width / 680);

        this.game.load.onFileComplete.add(this.fileComplete, this);

        loadImages(this.game);

        if (SOUNDS_ENABLED) {
            loadSounds(this.game);
        }
        this.loadLanguageSettings();

        //this._create();
        //-RPLC:PRELOADSTATE_PRELOAD-//
    },

    fileComplete: function (progress, cacheKey, success, totalLoaded, totalFiles) {
        //PPS_USE-SDK:iWIN
        /*
        iConsole.game.loadProgress( {progress: progress / 100.0} );
        //PPS_USE-SDK:iWIN
        */


        //LOG(progress + ' %');
        percentageText.text = progress + " %";
        if (progress >= 100) {
            //PPS_USE-SDK:iWIN
            /*
            iConsole.game.loadProgress( {progress: 1} );
            iConsole.game.loaded( {success: true} );
            //PPS_USE-SDK:iWIN
            */

            //PPS_DELETE-GRANDTECHNOLOGY
            this._create();
            //PPS_DELETE-GRANDTECHNOLOGY

            //PPS_USE-GRANDTECHNOLOGY
            /*
            getPlayItData(function (gameCanStart, errorMsg) {
                if (gameCanStart === true){
                    this._create();
                } else {
                    game.add.tween(percentageText).to( { alpha : 0 }, ScenesTransitions.TRANSITION_LENGTH * 1.4, "Linear", true, ScenesTransitions.TRANSITION_LENGTH * 3);
                    game.add.tween(imgSplash).to( { alpha : 0 }, ScenesTransitions.TRANSITION_LENGTH * 1.4, "Linear", true, ScenesTransitions.TRANSITION_LENGTH * 3);

                    var errorText = game.add.text(game.width/2, game.height/2, errorMsg.toUpperCase(), { font: '35px gameFont', fill:'#ffffff', align: "center", wordWrap: true, wordWrapWidth: game.width * 0.8});
                    errorText.anchor.set(0.5);
                    errorText.alpha = 0;
                    game.add.tween(errorText).to( { alpha : 1 }, ScenesTransitions.TRANSITION_LENGTH * 1.4, "Linear", true, ScenesTransitions.TRANSITION_LENGTH * 5);
                }
            }.bind(this));
            //PPS_USE-GRANDTECHNOLOGY
            */
        }
    },

    _create: function () {
        //game.add.tween(this.loadingBar).to( { alpha : 0 }, 500, ANIMATION_CUBIC_IO, true, 0, 0, false);
        //this.startGame();

        imgBtn.inputEnabled = true;
        imgBtn.events.onInputDown.add(this.inputListener, this);

        //this.continueText = this.game.add.text(this.game.world.centerX, loaderPosY + 2, START_TEXT[language], { font: '25px Arial', fill:'#FFFFFF'});
        //this.continueText.anchor.set(getCorrectAnchorX(this.continueText, 0.5));

        game.add.tween(percentageText)
            .to({alpha: 0}, ScenesTransitions.TRANSITION_LENGTH * 1.4, "Linear", true, ScenesTransitions.TRANSITION_LENGTH * 3, -1, true);

        var timeDelta = Date.now() - startTime;

        if (timeDelta < 3000) {
            game.time.events.add(3000 - timeDelta, function () {
                this.startGame();
            }, this);
        } else {
            this.startGame();
        }

        //this.startGame();

        //PPS_USE-INLOGICleaderboard
        /*
        if(typeof INLOGIC_LEADERBOARD !== "undefined") {INLOGIC_LEADERBOARD.logToSocialNet();}
        //PPS_USE-INLOGICleaderboard
        */
    },

    createMenuText: function (x, y, text) {
        var txtObj = new Phaser.Text(game, x, y, text, {fill: '#FED87F'});
        txtObj.anchor.x = getCorrectAnchorX(txtObj, 0.5);
        txtObj.anchor.y = getCorrectAnchorY(txtObj, 0.5);
        txtObj.shadowOffsetX = 3;
        txtObj.shadowOffsetY = 3;
        txtObj.shadowColor = '#660000';

        return txtObj;
    },

    loadLanguageSettings: function () {
        /*
        try {
            storedData = localStorage.getItem('plck-lang');
            if (storedData != null) {
                parsedData = JSON.parse(storedData);

                if (parsedData != null) {
                    parsedData = parseInt(parsedData);
                    if (parsedData >= 0 && parsedData < LANGUAGES_COUNT) {
                        language = parsedData;
                        languageLoaded = true;
                    } else {
                        language = LANGUAGE_EN;
                    }
                }
            }
        }catch (err) {
            language = LANGUAGE_EN;
        }
        */

        Languages.instance.language = "en";

        //PPS_DELETE-DISABLE_LANG_SCREEN
        var systemLanguage = navigator.userLanguage || navigator.language;
        if (systemLanguage.length >= 2) {
            systemLanguage = systemLanguage.substring(0, 2);
        }

        if (systemLanguage == "fr" || systemLanguage.substring(0, 2) === "fr") {
            Languages.instance.language = "fr";
        }
        if (systemLanguage == "it" || systemLanguage.substring(0, 2) === "it") {
            Languages.instance.language = "it";
        }
        if (systemLanguage == "de" || systemLanguage.substring(0, 2) === "de") {
            Languages.instance.language = "de";
        }
        if (systemLanguage == "es" || systemLanguage.substring(0, 2) === "es") {
            Languages.instance.language = "es";
        }
        if (systemLanguage == "pt" || systemLanguage.substring(0, 2) === "pt") {
            Languages.instance.language = "pt";
        }
        if (systemLanguage == "nl" || systemLanguage.substring(0, 2) === "nl") {
            Languages.instance.language = "nl";
        }
        if (systemLanguage == "ru" || systemLanguage.substring(0, 2) === "ru") {
            Languages.instance.language = "ru";
        }
        //PPS_DELETE-DISABLE_LANG_SCREEN

        //PPS_USE-YANDEX
        /*
        Languages.instance.language = "ru";
        // PPS_USE-YANDEX
        */

    },

    //update: function () {
    //    this.fpsText.text = this.game.time.fps;
    //},

    inputListener: function () {
        this.startGame();
    },

    startGame: function () {
        if (sceneLanguages != null) {
            return;
        }

        imgBtn.inputEnabled = false;
        imgBtn.events.onInputDown.dispose();
        this.game.world.remove(imgSplash);
        this.game.world.remove(imgBtn);

        ScenesTransitions.hideSceneAlpha(percentageText);

        game.state.start('GameState');
    },

    onResolutionChange: function () {
        loaderPosY = this.game.world.height / 5 * 4.5;

        imgSplash.reset(game.width / 2, game.height / 2);
        imgSplash.width = game.width;

        imgBtn.reset(game.width / 2, game.height / 2);
        imgBtn.scale.x = (game.width / 100) + 0.2;
        imgBtn.scale.y = (game.height / 100) + 0.2;

        percentageText.reset(this.game.world.centerX, this.game.height - 20);
    }
}