
var SceneGameOver = function () {
    SceneGameOver.instance = this;

    this.create();
};

SceneGameOver.instance = null;

SceneGameOver.prototype = {

    create: function () {
        SceneGameOver.DURATION_VAL_ANIM = ScenesTransitions.TRANSITION_LENGTH / 0.72;
        SceneGameOver.DELAY_VAL_ANIM = ScenesTransitions.TRANSITION_LENGTH / 1.8;

        grpSceneGameOver = game.add.group();
        grpSceneGameOver.name = "grpSceneGameOver";
        this.grpScene = grpSceneGameOver;

        // imgGameOverBG = game.add.sprite(game.width >> 1, game.height, GetSelectedBackground());
        // imgGameOverBG.anchor.setTo(0.5, 1);
        // grpSceneGameOver.addChild(imgGameOverBG);
        // imgGameOverBG.inputEnabled = true;

        imgGameOverShine = game.add.sprite(game.width >> 1, (game.height * 0.52), 'pak1', 'luce');
        //imgGameOverShine.blendMode = PIXI.blendModes.ADD;
        imgGameOverShine.anchor.setTo(0.5, 0.5);
        imgGameOverShine.scale.set(2.7);
        grpSceneGameOver.addChild(imgGameOverShine);

        gotGameOverRecord = false;

        //region TITLEF

        topBarGameOver = gameState.CreateCaptionBar(grpSceneGameOver, 'INGAME_RESULT_YOU_WIN');
        imgGameOverCoinsHolder = gameState.CreateCoinsHolder(grpSceneGameOver, topBarGameOver);

        //endregion

        //region CARDS
        this.initGameoverCards();

        tmpy = (game.height * 0.27);

        cardsDestinations = [];

        cardsDestinations[0] = { x: (game.width >> 1) - game.width / 3, y: tmpy };
        cardsDestinations[1] = { x: game.width >> 1, y: tmpy - game.height * 0.1 };
        cardsDestinations[2] = { x: (game.width >> 1) + game.width / 3, y: tmpy };
        cardsDestinations[3] = { x: game.width >> 1, y: tmpy + game.height * 0.1 };

        //endregion

        //region BARs

        imgGameOverBar1 = game.add.sprite(game.width >> 1, game.height >> 1, 'pak1', 'blank');
        imgGameOverBar1.anchor.setTo(0.5);
        imgGameOverBar1.tint = 0xB8B8B8;
        grpSceneGameOver.addChild(imgGameOverBar1);

        imgGameOverBar2 = game.add.sprite(game.width >> 1, game.height >> 1, 'pak1', 'blank');
        imgGameOverBar2.anchor.setTo(0.5);
        imgGameOverBar2.tint = 0x7a7a7a;
        grpSceneGameOver.addChild(imgGameOverBar2);

        //endregion

        //region COINS

        imgGameOverBonusFG = game.add.sprite(game.width >> 1, game.height, 'pak1', 'podmince');
        imgGameOverBonusFG.anchor.setTo(0.5);
        imgGameOverBonusFG.dspX = 0;
        grpSceneGameOver.addChild(imgGameOverBonusFG);

        imgGameOverBonusCoin = game.add.sprite(25, 0, 'pak1', 'mincaB');
        imgGameOverBonusCoin.anchor.setTo(0.5, 0.5);
        imgGameOverBonusCoin.scale.set(0.4);
        imgGameOverBonusFG.addChild(imgGameOverBonusCoin);

        txtGameOverBonusDailyVal = gameState.CreateText(0, -2, 'gamefont', '10', 35);
        txtGameOverBonusDailyVal.anchor.setTo(1, 0.5);
        txtGameOverBonusDailyVal.tint = 0xffffff;
        imgGameOverBonusFG.addChild(txtGameOverBonusDailyVal);

        txtGameOverBonusDaily = gameState.CreateText(imgGameOverBonusFG.width * 1.1, 0, 'gamefont', 'Daily', 35);
        txtGameOverBonusDaily.anchor.setTo(0.5);
        txtGameOverBonusDaily.tint = 0x000000;
        txtGameOverBonusDaily.align = 'center';
        imgGameOverBonusFG.addChild(txtGameOverBonusDaily);

        imgGameOverCoin = game.add.sprite(25, 0, 'pak1', 'mincaB');
        imgGameOverCoin.anchor.setTo(0.5);
        imgGameOverCoin.scale.set(0.7 * game.width / 680);
        grpSceneGameOver.addChild(imgGameOverCoin);

        txtGameOverCoinVal = gameState.CreateText(5, -game.width * 0.03, 'gamefont', '10', 50 * game.width / 680);
        txtGameOverCoinVal.anchor.setTo(1, 0.5);
        txtGameOverCoinVal.tint = 0x000000;
        grpSceneGameOver.addChild(txtGameOverCoinVal);

        //endregion

        //region BUTTONS

        btnGameOverNewgame = gameState.CreateImgButtonWithText(grpSceneGameOver, 'gombik2', '', function () {
            soundManager.playSound('menu-click1');
            SceneGame.instance.ResetGame();
            SceneGameOver.instance.HideAnimated();
        }, 0x000000);
        btnGameOverNewgame.scale.set(game.width / 680 * 0.5);

        // btnGameOverNewgameTxt = gameState.CreateText(5, -game.width * 0.03, 'gamefont', STR('NEW_GAME'), 50 * game.width / 680);
        // btnGameOverNewgameTxt.anchor.setTo(1, 0.5);
        // btnGameOverNewgameTxt.tint = 0x000000;
        // grpSceneGameOver.addChild(btnGameOverNewgameTxt);

        btnGameOverRetry = gameState.CreateImgButtonWithText(grpSceneGameOver, 'dialogbutton', 'Retry', function () {
            coinParticles.Reset();
            soundManager.playSound('menu-click1');
            SceneGame.instance.RetryGame();
            SceneGameOver.instance.HideAnimated();
        }, 0x000000);
        btnGameOverRetry.scale.set(game.width / 680 * 0.8);

        btnGameOverHome = gameState.CreateImgButtonWithText(grpSceneGameOver, 'dialogbutton', 'Home', function () {
            GameData.profile.savedMoved = 0;
            GameData.Save();
            gameRunning = false;

            soundManager.playSound('menu-click1');
            coinParticles.Reset();

            // SceneGame.instance.ResetGame();
            SceneGame.instance.HideAnimated();
            SceneGameOver.instance.HideAnimated();

            SceneMenu.instance.onResolutionChange();
            SceneMenu.instance.ShowAnimated();
            // grpScenePlay.visible = true;

            selectedMenuButton = null;
            SceneMenu.instance.SelectMenuButtonAnimated(btnMenuButtons[2]);
        }, 0x000000);
        btnGameOverHome.scale.set(game.width / 680 * 0.8);

        //endregion

        //region STATS

        txtGameOverScore = gameState.CreateText(30, 0, 'gamefont', 'SCORE', 32 * game.width / 680);
        txtGameOverScore.anchor.setTo(0, 0.5);
        txtGameOverScore.tint = 0xffffff;
        grpSceneGameOver.addChild(txtGameOverScore);

        txtGameOverTime = gameState.CreateText(30, 0, 'gamefont', 'TIME', 32 * game.width / 680);
        txtGameOverTime.anchor.setTo(0, 0.5);
        txtGameOverTime.tint = 0xffffff;
        grpSceneGameOver.addChild(txtGameOverTime);

        txtGameOverTotalW = gameState.CreateText(30, 0, 'gamefont', STR('STATS_TOTAL_WINS'), 32 * game.width / 680);
        txtGameOverTotalW.anchor.setTo(0, 0.5);
        txtGameOverTotalW.tint = 0xffffff;
        grpSceneGameOver.addChild(txtGameOverTotalW);

        txtGameOverScoreVal = gameState.CreateText(30, 0, 'gamefont', '0', 32 * game.width / 680);
        txtGameOverScoreVal.anchor.setTo(1, 0.5);
        txtGameOverScoreVal.tint = 0xffffff;
        grpSceneGameOver.addChild(txtGameOverScoreVal);

        imgGameOverScoreValBest = game.add.sprite(game.width * 0.025, 0, 'pak1', 'bestscore');
        imgGameOverScoreValBest.anchor.setTo(0.5, 0.5);
        imgGameOverScoreValBest.scale.set(0.6 * game.width / 680);
        txtGameOverScoreVal.addChild(imgGameOverScoreValBest);

        txtGameOverScoreValBest = gameState.CreateText(game.width * 0.125, -game.width * 0.008, 'gamefont', 'Best\nscore', 20 * game.width / 680);
        txtGameOverScoreValBest.anchor.setTo(0.5, 0.5);
        txtGameOverScoreValBest.tint = 0xffffff;
        txtGameOverScoreValBest.align = 'center';
        txtGameOverScoreVal.addChild(txtGameOverScoreValBest);

        txtGameOverTimeVal = gameState.CreateText(game.width * 0.044, 0, 'gamefont', '00:00', 32 * game.width / 680);
        txtGameOverTimeVal.anchor.setTo(1, 0.5);
        txtGameOverTimeVal.tint = 0xffffff;
        grpSceneGameOver.addChild(txtGameOverTimeVal);

        imgGameOverTimeValBest = game.add.sprite(game.width * 0.025, 0, 'pak1', 'bestscore');
        imgGameOverTimeValBest.anchor.setTo(0.5, 0.5);
        imgGameOverTimeValBest.scale.set(0.6);
        txtGameOverTimeVal.addChild(imgGameOverTimeValBest);

        txtGameOverTimeValBest = gameState.CreateText(game.width * 0.125, -game.width * 0.008, 'gamefont', 'Best\ntime', 32 * game.width / 680);
        txtGameOverTimeValBest.anchor.setTo(0.5, 0.5);
        txtGameOverTimeValBest.tint = 0xffffff;
        txtGameOverTimeValBest.align = 'center';
        txtGameOverTimeVal.addChild(txtGameOverTimeValBest);

        txtGameOverTotalWVal = gameState.CreateText(game.width * 0.044, 0, 'gamefont', '29', 32 * game.width / 680);
        txtGameOverTotalWVal.anchor.setTo(1, 0.5);
        txtGameOverTotalWVal.tint = 0xffffff;
        grpSceneGameOver.addChild(txtGameOverTotalWVal);
        //endregion

        grpSceneGameOver.visible = false;
    },

    UpdateGamesStats: function () {
        GameData.profile.savedGame = null;
        GameData.Save();

        coinsWon = 10;

        if (GameData.profile.Draw1) {
            txtGameOverTotalWVal.text = '' + GameData.profile.TotalWinsD1;
            GameData.profile.TotalWinsD1++;
        }
        else {
            txtGameOverTotalWVal.text = '' + GameData.profile.TotalWinsD3;
            GameData.profile.TotalWinsD3++;
        }
        imgGameOverCoinsHolder.txtPrice.text = '' + GameData.profile.PlayerCoins;
        txtGameOverCoinVal.text = '' + coinsWon;

        GameData.profile.PlayerCoins += coinsWon;

        gotGameOverRecord = false;

        imgGameOverScoreValBest.visible = false;
        txtGameOverScoreValBest.visible = false;
        imgGameOverTimeValBest.visible = false;
        txtGameOverTimeValBest.visible = false;
    },

    ReloadCardFaces: function () {

    },

    ReloadCardBacks: function () {

    },

    ResetGameOverCards: function () {
        if (imgGameOverCards.length < 4) {
            this.initGameoverCards();
        }

        if (prepareCardsActivated) {
            for (var j = 0; j < imgGameOverCards.length; j++)
                for (var i = 0; i < imgGameOverCards[j].length; i++) {
                    try {
                        if (GameData.profile.UsedCardFace === 3) {
                            imgGameOverCards[j][i].loadTexture('game2');
                            imgGameOverCards[j][i].frameName = GetCardFrame(grpColorSlots[j].children[0].cardFrame + i);
                        } else {
                            imgGameOverCards[j][i].loadTexture('game');
                            imgGameOverCards[j][i].frameName = GetCardFrame(grpColorSlots[j].children[0].cardFrame + i);
                        }


                    } catch (e) {
                        if (GameData.profile.UsedCardFace === 3) {
                            imgGameOverCards[j][i].loadTexture('game2');
                            imgGameOverCards[j][i].frameName = GetCardFrame(j * 13 + i);
                        } else {
                            imgGameOverCards[j][i].loadTexture('game');
                            imgGameOverCards[j][i].frameName = GetCardFrame(j * 13 + i);
                        }
                    }
                    if (imgGameOverCards[j][i].twnMove != null)
                        imgGameOverCards[j][i].twnMove.stop();
                    game.tweens.removeFrom(imgGameOverCards[j][i], true);
                    imgGameOverCards[j][i].position.setTo(grpColorSlots[j].x, grpColorSlots[j].y);
                }

            removeColorSlots();
            prepareCardsActivated = false;
        }
    },

    AnimateGameOverCards: function () {
        SceneGameOver.instance.ResetGameOverCards();

        cardsDestinations[0] = { x: (game.width >> 1) - game.width / 3, y: tmpy };
        cardsDestinations[1] = { x: game.width >> 1, y: tmpy - game.height * 0.1 };
        cardsDestinations[2] = { x: (game.width >> 1) + game.width / 3, y: tmpy };
        cardsDestinations[3] = { x: game.width >> 1, y: tmpy + game.height * 0.1 };

        var DURATION = ScenesTransitions.TRANSITION_LENGTH * 2;
        var DELAY = ScenesTransitions.TRANSITION_LENGTH / 3;

        for (var j = 0; j < imgGameOverCards.length; j++)
            for (var i = 0; i < imgGameOverCards[j].length; i++) {
                var callback = ((j == imgGameOverCards.length - 1) && (i == imgGameOverCards[j].length - 1)) ? SceneGameOver.instance.CardsOnPositions : null;
                gameState.MoveSpriteBezier(imgGameOverCards[j][i], cardsDestinations[j].x, cardsDestinations[j].y, DURATION, j * (3 * ScenesTransitions.TRANSITION_LENGTH) + i * DELAY, 1, callback, null)
            }

    },

    AnimateGameOverStatValues: function () {
        imgGameOverCoin.dspX = 0;
        imgGameOverCoin.position.setTo((game.width >> 1) - imgGameOverCoin.dspX + 25, imgGameOverBar1.top + (imgGameOverBar2.top - imgGameOverBar1.top) / 2);
        txtGameOverCoinVal.position.setTo(imgGameOverCoin.x - imgGameOverCoin.width * 0.5, imgGameOverCoin.y - (txtGameOverCoinVal.height >> 3))

        imgGameOverBonusFG.dspX = game.width * 0.6;
        imgGameOverBonusFG.position.setTo((game.width >> 1) + imgGameOverBonusFG.dspX, imgGameOverBar1.top + (imgGameOverBar2.top - imgGameOverBar1.top) / 2);

        var DURATION = 1000;
        var DELAY = 200;

        SceneGameOver.instance._animateScoreVal();
    },

    _animateScoreVal: function () {
        SceneGameOver.instance.TweenTextNumericVal(txtGameOverScoreVal, gameScore, SceneGameOver.DURATION_VAL_ANIM, SceneGameOver.DELAY_VAL_ANIM, SceneGameOver.instance._animateTimeVal);
    },

    _animateTimeVal: function () {
        soundManager.playSound('result_item_appear');
        SetPoingScaleTween(txtGameOverScoreVal);
        SceneGameOver.instance._updateScoreStuff();

        SceneGameOver.instance.TweenTextTimeVal(txtGameOverTimeVal, gameTimer, SceneGameOver.DURATION_VAL_ANIM, SceneGameOver.DELAY_VAL_ANIM, function () {
            soundManager.playSound('result_item_appear');
            SetPoingScaleTween(txtGameOverTimeVal);
            SceneGameOver.instance._updateTimeStuff();
            SetPoingScaleTween(txtGameOverTotalWVal, ScenesTransitions.TRANSITION_LENGTH, SceneGameOver.DELAY_VAL_ANIM, function () {
                soundManager.playSound('result_item_appear');
                if (GameData.profile.Draw1)
                    txtGameOverTotalWVal.text = '' + GameData.profile.TotalWinsD1;
                else
                    txtGameOverTotalWVal.text = '' + GameData.profile.TotalWinsD3;
                SceneGameOver.instance.AnimateGameOverWinnings();
            });
        });
    },

    _updateScoreStuff: function () {
        scnGame.UpdateAchievementsBestScore();
        if (GameData.profile.Draw1) {
            if (GameData.profile.BestScoreD1 < gameScore) {
                GameData.profile.BestScoreD1 = gameScore;
                imgGameOverScoreValBest.visible = true;
                txtGameOverScoreValBest.visible = true;
            }
        } else {
            if (GameData.profile.BestScoreD3 < gameScore) {
                GameData.profile.BestScoreD3 = gameScore;
                gotGameOverRecord = true;
                imgGameOverScoreValBest.visible = false;
                txtGameOverScoreValBest.visible = false;
            }
        }
    },

    _animateTotalWinsVal: function () {

    },

    _updateTimeStuff: function () {
        if (GameData.profile.Draw1) {
            if ((GameData.profile.BestTimeD1 > gameTimer) || (GameData.profile.BestTimeD1 == 0)) {
                GameData.profile.BestTimeD1 = gameTimer;
                gotGameOverRecord = true;
                imgGameOverTimeValBest.visible = false;
                txtGameOverTimeValBest.visible = false;
            }
            if ((GameData.profile.LeastMovesD1 > gameMoves) || (GameData.profile.LeastMovesD1 == 0)) {
                GameData.profile.LeastMovesD1 = gameMoves;
                gotGameOverRecord = true;
            }
            if (GameData.profile.MostMovesD1 < gameMoves) {
                GameData.profile.MostMovesD1 = gameMoves;
                //toto asi nie je rekord....
                //gotGameOverRecord = true;
            }
        } else {
            if ((GameData.profile.BestTimeD3 > gameTimer) || (GameData.profile.BestTimeD3 == 0)) {
                GameData.profile.BestTimeD3 = gameTimer;
                gotGameOverRecord = true;
                imgGameOverTimeValBest.visible = false;
                txtGameOverTimeValBest.visible = false;
            }
            if ((GameData.profile.LeastMovesD3 > gameMoves) || (GameData.profile.LeastMovesD3 == 0)) {
                GameData.profile.LeastMovesD3 = gameMoves;
                gotGameOverRecord = true;
            }
            if (GameData.profile.MostMovesD3 < gameMoves) {
                GameData.profile.MostMovesD3 = gameMoves;
                //toto asi nie je rekord....
                //gotGameOverRecord = true;
            }
        }
    },

    AnimateGameOverWinnings: function () {
        var dailyBonusAvail = new Date(GameData.profile.DailyBonusDate) <= (new Date());

        if (!dailyBonusAvail) {
            coinParticles.AnimateCoins(coinsWon, imgGameOverCoin, imgGameOverCoinsHolder.itemCoin, txtGameOverCoinVal, imgGameOverCoinsHolder.txtPrice, function () {
                GameData.profile.PlayerCoins = imgGameOverCoinsHolder.txtPrice.val;
                GameData.Save();

                SceneGameOver.instance.AnimateGameOverCards();
            }, null, 0.8 * game.width / 680, 0.5 * game.width / 680);
            return;
        }

        GameData.profile.DailyBonusDate = StrDateNextDay(DateToStr(new Date()));
        GameData.Save();

        imgGameOverBonusFG.twnDspX = game.add.tween(imgGameOverBonusFG);
        imgGameOverBonusFG.twnDspX.to({ dspX: 0 }, SceneGameOver.DURATION_VAL_ANIM, Phaser.Easing.Back.Out, true, SceneGameOver.DELAY_VAL_ANIM);

        imgGameOverBonusFG.twnDspX.onUpdateCallback(function () {
            imgGameOverBonusFG.position.setTo((game.width >> 1) + imgGameOverBonusFG.width * 0.3 + imgGameOverBonusFG.dspX, imgGameOverBar1.top + (imgGameOverBar2.top - imgGameOverBar1.top) / 2);
        }, this);

        imgGameOverCoin.twnDspX = game.add.tween(imgGameOverCoin);
        imgGameOverCoin.twnDspX.to({ dspX: imgGameOverBonusFG.width * 0.8 }, SceneGameOver.DURATION_VAL_ANIM, Phaser.Easing.Back.Out, true, SceneGameOver.DELAY_VAL_ANIM);

        imgGameOverCoin.twnDspX.onUpdateCallback(function () {
            imgGameOverCoin.position.setTo((game.width >> 1) - imgGameOverCoin.dspX + 25, imgGameOverBar1.top + (imgGameOverBar2.top - imgGameOverBar1.top) / 2);
            txtGameOverCoinVal.position.setTo(imgGameOverCoin.x - imgGameOverCoin.width * 0.5, imgGameOverCoin.y - (txtGameOverCoinVal.height >> 3));
        }, this);

        imgGameOverBonusFG.twnDspX.onComplete.add(function () {
            coinParticles.AnimateCoins(15, imgGameOverBonusCoin, imgGameOverCoin, txtGameOverBonusDailyVal, txtGameOverCoinVal, function () {
                coinParticles.AnimateCoins(txtGameOverCoinVal.val, imgGameOverCoin, imgGameOverCoinsHolder.itemCoin, txtGameOverCoinVal, imgGameOverCoinsHolder.txtPrice, function () {
                    GameData.profile.PlayerCoins = imgGameOverCoinsHolder.txtPrice.val;
                    GameData.Save();

                    SceneGameOver.instance.AnimateGameOverCards();
                }, null, 0.8 * game.width / 680, imgGameOverCoinsHolder.itemCoin.scale.x);
            }, null, 0.5 * game.width / 680, 0.8 * game.width / 680);
        });
    },

    TweenTextNumericVal: function (txtObj, val, duration, delay, callback) {
        txtObj.finVal = val;
        txtObj.val = 0;
        txtObj.twnVal = game.add.tween(txtObj);
        txtObj.twnVal.to({ val: val }, duration, "Linear", true, delay);
        txtObj.twnVal.onUpdateCallback(function () {
            this.txtObj.text = '' + Math.floor(this.txtObj.val);
        }, { txtObj: txtObj });
        txtObj.twnVal.onComplete.add(function () {
            this.txtObj.text = '' + Math.floor(this.txtObj.finVal);
            if (this.callback != null)
                this.callback();
        }, { txtObj: txtObj, callback: callback });

    },

    TweenTextTimeVal: function (txtObj, val, duration, delay, callback) {
        txtObj.finVal = val;
        txtObj.val = 0;
        txtObj.twnVal = game.add.tween(txtObj);
        txtObj.twnVal.to({ val: val }, duration, "Linear", true, delay);
        txtObj.twnVal.onUpdateCallback(function () {
            this.txtObj.text = '' + millisecondsToTimeStr(this.txtObj.val);
        }, { txtObj: txtObj });
        txtObj.twnVal.onComplete.add(function () {
            this.txtObj.text = '' + millisecondsToTimeStr(this.txtObj.finVal);
            if (this.callback != null)
                this.callback();
        }, { txtObj: txtObj, callback: callback });

    },

    CardsOnPositions: function () {
        LOG('CardsOnPositions');

        var tmp = cardsDestinations[0]
        for (var i = 0; i < cardsDestinations.length - 1; i++)
            cardsDestinations[i] = cardsDestinations[i + 1]
        cardsDestinations[cardsDestinations.length - 1] = tmp;

        var DURATION = 600;
        var DELAY = 100;

        for (var j = 0; j < imgGameOverCards.length; j++)
            for (var i = 0; i < imgGameOverCards[j].length; i++) {
                var callback = ((j == imgGameOverCards.length - 1) && (i == imgGameOverCards[j].length - 1)) ? SceneGameOver.instance.CardsOnPositions : null;
                gameState.MoveSpriteBezier(imgGameOverCards[j][i], cardsDestinations[j].x, cardsDestinations[j].y, DURATION, j * 300 + i * DELAY, 1, callback, null)
            }
    },

    onResolutionChange: function () {
        // imgGameOverBG.loadTexture(GetSelectedBackground());

        var itemH = game.height / 8;

        topBarGameOver.width = game.width * 1.1;
        topBarGameOver.height = itemH;
        topBarGameOver.itemAnchor.scale.setTo(1 / topBarGameOver.scale.x, 1 / topBarGameOver.scale.y);
        topBarGameOver.y = topBarGameOver.height / 2;

        imgGameOverShine.height = game.height * 1.3;
        imgGameOverShine.scale.x = imgGameOverShine.scale.y;
        imgGameOverShine.position.setTo(game.width >> 1, (game.height * 0.52));

        // imgGameOverBG.width = game.width;
        // imgGameOverBG.scale.y = imgGameOverBG.scale.x;
        // imgGameOverBG.position.setTo(game.width >> 1, game.height);

        imgGameOverBar1.width = game.width * 1.1;
        imgGameOverBar1.height = (game.height >> 1) * 1.2;
        imgGameOverBar1.position.setTo(game.width >> 1, game.height - (imgGameOverBar1.height * 0.45));

        imgGameOverBar2.width = game.width * 1.1;
        imgGameOverBar2.height = (imgGameOverBar1.height / 5) * 2;
        imgGameOverBar2.position.setTo(game.width >> 1, imgGameOverBar1.y - imgGameOverBar2.height / 3);// + (imgGameOverBG.height / 5));

        imgGameOverBonusFG.position.setTo((game.width >> 1) + imgGameOverBonusFG.dspX + (game.width * 0.6), imgGameOverBar1.top + (imgGameOverBar2.top - imgGameOverBar1.top) / 2);
        imgGameOverCoin.position.setTo((game.width >> 1) - imgGameOverCoin.dspX, imgGameOverBar1.top + (imgGameOverBar2.top - imgGameOverBar1.top) / 2);
        txtGameOverCoinVal.position.setTo(imgGameOverCoin.x - imgGameOverCoin.width * 0.5, imgGameOverCoin.y - game.width * 0.008);

        btnGameOverNewgame.position.setTo(game.width >> 1, game.height - imgGameOverBar2.height / 2 - btnGameOverNewgame.height * 0.55);
        btnGameOverRetry.position.setTo((game.width >> 1) - (btnGameOverNewgame.width >> 2), game.height - imgGameOverBar2.height / 2 + btnGameOverNewgame.height * 0.45);
        btnGameOverHome.position.setTo((game.width >> 1) + (btnGameOverNewgame.width >> 2), game.height - imgGameOverBar2.height / 2 + btnGameOverNewgame.height * 0.45);

        txtGameOverScore.position.setTo((game.width >> 1) - game.width / 3.5, imgGameOverBar2.y - btnGameOverRetry.height * 0.7);
        txtGameOverTime.position.setTo((game.width >> 1) - game.width / 3.5, imgGameOverBar2.y);
        txtGameOverTotalW.position.setTo((game.width >> 1) - game.width / 3.5, imgGameOverBar2.y + btnGameOverRetry.height * 0.7);

        txtGameOverScoreVal.position.setTo((game.width >> 1) + game.width / 3.5, imgGameOverBar2.y - btnGameOverRetry.height * 0.7);
        txtGameOverTimeVal.position.setTo((game.width >> 1) + game.width / 3.5, imgGameOverBar2.y);
        txtGameOverTotalWVal.position.setTo((game.width >> 1) + game.width / 3.5, imgGameOverBar2.y + btnGameOverRetry.height * 0.7);

        // updateTextToWidth(imgGameOverCoinsHolder.children[1], 40 * game.width / 680, 'gameFont', (imgGameOverCoinsHolder.width - imgGameOverCoinsHolder.children[0].width));

    },

    update: function () {
        imgGameOverShine.angle += 0.5;
    },

    updateTexts: function () {
        txtGameOverScoreValBest.text = STR('STATS_BEST_SCORE').replaceAll(' ', '\n');
        txtGameOverTimeValBest.text = STR('STATS_BEST_TIME').replaceAll(' ', '\n');

        txtGameOverBonusDaily.text = STR('DAILY_BONUS');
        // updateBitmapTextToHeight(txtGameOverBonusDaily, 35, imgGameOverBonusFG.height * 0.9);
        updateBitmapTextToWidth(txtGameOverBonusDaily, 25, game.width * 0.3);

        txtGameOverScore.text = STR('SCORE');
        txtGameOverTime.text = STR('TIME');
        txtGameOverTotalW.text = STR('STATS_TOTAL_WINS');
        topBarGameOver.txtCaption.text = STR('INGAME_RESULT_YOU_WIN');

        btnGameOverRetry.txtCaption.text = STR('RETRY');
        btnGameOverNewgame.txtCaption.text = STR('NEW_GAME');
        btnGameOverHome.txtCaption.text = STR('HOME');

        updateBitmapTextToWidth(btnGameOverRetry.txtCaption, 35, btnGameOverRetry.width * 0.8 / btnGameOverRetry.scale.x);
        updateBitmapTextToWidth(btnGameOverNewgame.txtCaption, 70, btnGameOverNewgame.width);
        updateBitmapTextToWidth(btnGameOverHome.txtCaption, 35, btnGameOverHome.width * 0.8 / btnGameOverHome.scale.x);
    },

    ShowAnimated: function () {
        soundManager.playSound('jingle_win');
        prepareCardsActivated = true;

        SceneGameOver.instance.onResolutionChange();
        SceneGameOver.instance.UpdateGamesStats();
        SceneGameOver.instance.ResetGameOverCards();
        SceneGameOver.instance.AnimateGameOverStatValues();

        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
        ScenesTransitions.showSceneAlpha(grpSceneGameOver, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
    },

    HideAnimated: function () {
        // SceneGameOver.instance.ResetGameOverCards();//mozno vymazat
        this.removeGameoverCards();
        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
        ScenesTransitions.hideSceneAlpha(grpSceneGameOver, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
    },

    removeGameoverCards: function () {
        for (var idx = 0; idx < imgGameOverCards.length; idx++) {
            for (var cardIdx = 0; cardIdx < imgGameOverCards[idx].length; cardIdx++) {
                imgGameOverCards[idx][cardIdx].destroy();
            }
        }

        imgGameOverCards = [];
    },

    initGameoverCards: function () {
        imgGameOverCards = [];
        for (var j = 0; j < 4; j++) {
            imgGameOverCards[j] = [];
            for (var i = 0; i < 13; i++) {
                if (GameData.profile.UsedCardFace === 3) {
                    imgGameOverCards[j][i] = game.add.sprite(-1000, -1000, 'game2', GetCardFrame(j * 13 + i));
                } else {
                    imgGameOverCards[j][i] = game.add.sprite(-1000, -1000, 'game', GetCardFrame(j * 13 + i));
                }
                imgGameOverCards[j][i].scale.set(game.width / 680 * 0.7);
                imgGameOverCards[j][i].anchor.set(0.5);
                imgGameOverCards[j][i].twnMove = null;
            }
        }
    }
}