var SceneOverlay = function()
{
    SceneOverlay.instance = this;

    this.create();
};

SceneOverlay.instance = null;

SceneOverlay.prototype = {

    create: function ()
    {
        grpSceneOverlay = game.add.group();
        grpSceneOverlay.name = 'grpSceneOverlay';

        imgOverlay = grpSceneOverlay.create(game.width >> 1, game.height >> 1, 'pak1', 'blank');
        imgOverlay.anchor.set(0.5);
        imgOverlay.width = game.width;
        imgOverlay.height = game.height;
        imgOverlay.alpha = 0.8;
        imgOverlay.tint = 0x1D1D1D;
        imgOverlay.inputEnabled = true;

        grpSceneOverlay.visible = false;
    },

    onResolutionChange: function()
    {
        imgOverlay.reset(game.width >> 1, game.height >> 1);
        imgOverlay.width = game.width * 1.1;
        imgOverlay.height = game.height * 1.1;
    },

    ShowAnimated: function()
    {
        SceneOverlay.instance.onResolutionChange();
        ScenesTransitions.showSceneAlpha(grpSceneOverlay, 0, ScenesTransitions.TRANSITION_LENGTH);
    },

    HideAnimated: function()
    {
        ScenesTransitions.hideSceneAlpha(grpSceneOverlay, 0, ScenesTransitions.TRANSITION_LENGTH);
    }
}