var ScenePause = function () {
    ScenePause.instance = this;

    this.create();
};

ScenePause.instance = null;

ScenePause.prototype = {

    create: function () {
        grpScenePause = game.add.group();
        grpScenePause.name = "grpScenePause";
        this.grpScene = grpScenePause;

        imgPauseOverlay = game.add.sprite(game.width >> 1, game.height >> 1, 'pak1', 'blank');
        imgPauseOverlay.anchor.setTo(0.5);
        imgPauseOverlay.tint = 0x354854;
        imgPauseOverlay.alpha = 0.7;
        imgPauseOverlay.inputEnabled = true;
        grpScenePause.addChild(imgPauseOverlay);
        /*
                btnPauseInstructions = game.add.sprite(game.width >> 1, game.height >> 1, 'pak1', 'tutorial-button');
                btnPauseInstructions.anchor.setTo(0.5, 0.5);
                btnPauseInstructions.scale.set(game.width / 680 * 0.7);
                AddButtonEvents(btnPauseInstructions, function(){
                    soundManager.playSound('menu-click1');
                    SceneInstructions.instance.ShowAnimated();
                }, ButtonOnInputOver, ButtonOnInputOut);
                grpScenePause.addChild(btnPauseInstructions);
        */
        btnPauseClose = game.add.sprite(game.width >> 1, game.height >> 1, 'pak1', 'quit');
        btnPauseClose.anchor.setTo(0.5, 0.5);
        btnPauseClose.scale.set(game.width / 680 * 0.7);
        AddButtonEvents(btnPauseClose, function () {
            soundManager.playSound('menu-click1');
            /*gameRunning = true;
            ScenePause.instance.HideAnimated();
            SceneMenu.instance.HideAnimated();*/
            SceneMenu.instance.QuitGame();
        }, ButtonOnInputOver, ButtonOnInputOut);
        grpScenePause.addChild(btnPauseClose);
        btnPauseClose.visible = (game.device.cocoonJS);

        pauseButtons = [];
        pauseButtons.push(gameState.CreateImgButtonWithText(grpScenePause, 'gombik2', 'RESUME', function () {

            adinplay_onAdStarted = function () {
                game.paused = false;

                if (gameTimer > 0 && !startTimer) startTimer = true;

                soundManager.playSound('menu-click1');
                gameRunning = true;
                ScenePause.instance.HideAnimated();
                SceneMenu.instance.HideAnimated();
            }.bind(this);
            adinplay_onAdFinished = function () { };
            adinplay_playVideoAd();

        }, 0x000000));
        pauseButtons.push(gameState.CreateImgButtonWithText(grpScenePause, 'gombik2', 'RETRY', function () {

            adinplay_onAdStarted = function () {
                game.paused = false;


                soundManager.playSound('menu-click1');
                SceneGame.instance.onGameOver(GAME_OVER_BY_USER);
                SceneGame.instance.RetryGame();
                ScenePause.instance.HideAnimated();
                SceneMenu.instance.HideAnimated();

            }.bind(this);
            adinplay_onAdFinished = function () { };
            adinplay_playVideoAd();

        }, 0x000000));
        pauseButtons.push(gameState.CreateImgButtonWithText(grpScenePause, 'gombik2', 'NEW_GAME', function () {
            soundManager.playSound('menu-click1');
            SceneGame.instance.onGameOver(GAME_OVER_BY_USER);
            SceneGame.instance.ResetAchievementsWinOnRestart();
            SceneGame.instance.ResetGame();
            ScenePause.instance.HideAnimated();
            SceneMenu.instance.HideAnimated();
        }, 0x000000));

        //PPS_USE-CLOUDGAMES
        /*
        var cloudBtn = game.add.sprite((game.width - 160), game.height - 230, 'cloudApiImg');
        cloudBtn.scale.set(0.2);
        cloudBtn.events.onInputDown.add(cloudGames_moregames_link);
        cloudBtn.inputEnabled = true;
        cloudBtn.isClickable = true;
        grpScenePause.add(cloudBtn);
        //PPS_USE-CLOUDGAMES
        */

        //PPS_USE-SPILGAMES
        /*
        var spilLogo = null;
        var logoData = spilApiInstance.Branding.getLogo();
        if (logoData.image) {
            spilLogo = game.add.image(0, 0, 'spilLogoImg');
            spilLogo.inputEnabled = true;
            spilLogo.events.onInputUp.add(function (btn) {
                logoData.action();
                btn.tint = 0xFFFFFF;
            }, this);
            spilLogo.events.onInputOver.add(function (btn) {
                btn.tint = 0x999999;
            }, this);
            spilLogo.events.onInputOut.add(function (btn) {
                btn.tint = 0xFFFFFF;
            }, this);
            spilLogo.x = 10 + (spilLogo.width >> 1);
            spilLogo.y = 10 + (spilLogo.height >> 1);
            spilLogo.anchor.set(0, 0.5);
            grpScenePause.add(spilLogo);
        }

        var btn = grpScenePause.create(game.width >> 1, game.height >> 1, 'pak1', 'gombik2');
        btn.anchor.set(0.5);
        btn.STR = 'MORE_GAMES';
        btn.inputEnabled = true;

        var txtCaption = gameState.CreateText(0, -5, 'gamefont', STR('MORE_GAMES'), 28 * game.width / 680);
        txtCaption.anchor.setTo(0.5, 0.5);
        txtCaption.tint = 0xffffff;
        txtCaption.align = 'center';
        btn.addChild(txtCaption);
        btn.txtCaption = txtCaption;


        btn.events.onInputUp.add(function (btn) {
            soundManager.playSound('menu-click1');
            var buttonProperties = spilApiInstance.Branding.getLink('more_games');
            buttonProperties.action();
            btn.tint = 0xFFFFFF;
        }, this);
        btn.events.onInputOver.add(function (btn) {
            btn.tint = 0x999999;
        }, this);
        btn.events.onInputOut.add(function (btn) {
            btn.tint = 0xFFFFFF;
        }, this);
        pauseButtons.push(btn);
        //PPS_USE-SPILGAMES
        */

        imgPauseDrawOff = game.add.sprite((game.width >> 1), (game.height >> 1) * 0.7, 'pak1', 'drawoff');
        imgPauseDrawOff.anchor.set(0.5);
        imgPauseDrawOff.scale.set(game.width / 680 * 0.7);
        grpScenePause.add(imgPauseDrawOff);

        imgPauseDraw1 = game.add.sprite(0, 0, 'pak1', 'draw1');
        imgPauseDraw1.anchor.setTo(1, 0.5);
        imgPauseDrawOff.addChild(imgPauseDraw1);

        // imgPauseDrawOff.txtCaption1 = gameState.CreateText(-imgPauseDraw1.width * 0.35, -7, 'gamefont', 'Draw 1', 50);
        // imgPauseDrawOff.txtCaption1.anchor.setTo(0.5, 0.5);
        // imgPauseDrawOff.txtCaption1.tint = 0x000000;
        // imgPauseDrawOff.addChild(imgPauseDrawOff.txtCaption1);

        imgPauseDraw3 = game.add.sprite(0, 0, 'pak1', 'draw3');
        imgPauseDraw3.anchor.setTo(0, 0.5);
        imgPauseDrawOff.addChild(imgPauseDraw3);
        imgPauseDraw3.visible = false;

        // imgPauseDrawOff.txtCaption2 = gameState.CreateText(imgPauseDraw1.width * 0.35, -7, 'gamefont', 'Draw 3', 50);
        // imgPauseDrawOff.txtCaption2.anchor.setTo(0.5, 0.5);
        // imgPauseDrawOff.txtCaption2.tint = 0x000000;
        // imgPauseDrawOff.addChild(imgPauseDrawOff.txtCaption2);

        grpPauseLeftDraw = game.add.group();
        grpScenePause.add(grpPauseLeftDraw);

        imgPauseDraw1Icon = game.add.sprite(0, 0, 'pak1', 'card1');
        imgPauseDraw1Icon.scale.setTo(0.6);
        imgPauseDraw1Icon.anchor.setTo(0, 0.5);
        grpPauseLeftDraw.addChild(imgPauseDraw1Icon);

        txtDraw1 = gameState.CreateText(imgPauseDraw1Icon.width * 1.1, -5, 'gamefont', STR('DRAW_1'), 50);
        txtDraw1.anchor.setTo(0, 0.5);
        txtDraw1.tint = 0x000000;
        grpPauseLeftDraw.addChild(txtDraw1);


        grpPauseRightDraw = game.add.group();
        grpScenePause.add(grpPauseRightDraw);

        imgPauseDraw3Icon = game.add.sprite(0, 0, 'pak1', 'card3');
        imgPauseDraw3Icon.scale.setTo(0.6);
        imgPauseDraw3Icon.anchor.setTo(0.5);
        grpPauseRightDraw.addChild(imgPauseDraw3Icon);

        txtDraw3 = gameState.CreateText(imgPauseDraw1Icon.width * 1.1, -5, 'gamefont', STR('DRAW_3'), 50);
        txtDraw3.anchor.setTo(0, 0.5);
        txtDraw3.tint = 0x000000;
        grpPauseRightDraw.addChild(txtDraw3);

        btnPlayDraw = game.add.sprite(0, 0, 'pak1', 'void');
        btnPlayDraw.anchor.setTo(0.5, 0.5);
        btnPlayDraw.width = imgPauseDrawOff.width / imgPauseDrawOff.scale.x;
        btnPlayDraw.height = imgPauseDrawOff.height / imgPauseDrawOff.scale.y;
        imgPauseDrawOff.addChild(btnPlayDraw);
        AddButtonEvents(btnPlayDraw, ScenePause.instance.OnPressedPlayDraw, ButtonOnInputOver, ButtonOnInputOut);

        grpScenePause.visible = false;
    },

    OnPressedPlayDraw: function () {
        soundManager.playSound('menu-click1');

        if (game.input.x < game.width >> 1) {
            if (imgPauseDraw3.visible) {
                SceneDialog.instance.ShowAnimated('REDEAL_SWITCH_TEXT_DRAW_1', 'REDEAL_BUTTON_REDEAL', 'REDEAL_BUTTON_CANCEL', function () {
                    soundManager.playSound('menu-click1');
                    SceneGame.instance.onGameOver(GAME_OVER_BY_USER);
                    GameData.profile.Draw1 = true;
                    scnGame.ResetAchievementsWinOnRestart();
                    scnGame.ResetGame();
                    SceneDialog.instance.HideAnimated();
                    imgPauseDraw1.visible = true;
                    imgPauseDraw3.visible = false;
                    ScenePause.instance.HideAnimated();
                    SceneMenu.instance.HideAnimated();

                    grpPlayLeftDraw.children[0].tint = 0x000000;
                    grpPlayLeftDraw.children[1].tint = 0x000000;
                    grpPlayRightDraw.children[0].tint = 0xB8B8B8;
                    grpPlayRightDraw.children[1].tint = 0xB8B8B8;
                });
                return;
            }

        } else {
            if (imgPauseDraw1.visible) {
                //dialogTextSTR, button1STR, button2STR, button1callback, button2callback)
                SceneDialog.instance.ShowAnimated('REDEAL_SWITCH_TEXT_DRAW_3', 'REDEAL_BUTTON_REDEAL', 'REDEAL_BUTTON_CANCEL', function () {
                    soundManager.playSound('menu-click1');
                    SceneGame.instance.onGameOver(GAME_OVER_BY_USER);
                    GameData.profile.Draw1 = false;
                    scnGame.ResetAchievementsWinOnRestart();
                    scnGame.ResetGame();
                    SceneDialog.instance.HideAnimated();
                    imgPauseDraw1.visible = false;
                    imgPauseDraw3.visible = true;
                    ScenePause.instance.HideAnimated();
                    SceneMenu.instance.HideAnimated();

                    grpPauseRightDraw.children[0].tint = 0x000000;
                    grpPauseRightDraw.children[1].tint = 0x000000;
                    grpPauseLeftDraw.children[0].tint = 0xB8B8B8;
                    grpPauseLeftDraw.children[1].tint = 0xB8B8B8;
                });
                return;
            }
        }
    },

    onResolutionChange: function () {
        imgPauseOverlay.width = game.width * 1.2;
        imgPauseOverlay.height = game.height * 1.1;
        imgPauseOverlay.position.setTo(game.width >> 1, game.height >> 1);

        // btnPauseInstructions.position.setTo(btnPauseClose.width * 0.8, btnPauseClose.width * 0.8);
        btnPauseClose.position.setTo(game.width - btnPauseClose.width * 0.8, btnPauseClose.width * 0.8);

        itemH = game.height / 10 * 0.9;

        var itemGap = 15;
        var posY = (game.height - itemH * 4 - itemGap * 3) / 2 + itemH;

        for (var i = 0; i < pauseButtons.length; i++) {
            pauseButtons[i].height = itemH;
            pauseButtons[i].scale.x = pauseButtons[i].scale.y;
            pauseButtons[i].y = posY;
            pauseButtons[i].txtCaption.scale.setTo(1 / pauseButtons[i].scale.x, 1 / pauseButtons[i].scale.y);

            updateBitmapTextToWidth(pauseButtons[i].txtCaption, 35, pauseButtons[i].width * 1.8);

            posY += itemGap + itemH;
        }

        pauseButtons[0].txtCaption.fontSize = Math.min(pauseButtons[0].txtCaption.fontSize, pauseButtons[1].txtCaption.fontSize, pauseButtons[2].txtCaption.fontSize);
        pauseButtons[1].txtCaption.fontSize = pauseButtons[0].txtCaption.fontSize;
        pauseButtons[2].txtCaption.fontSize = pauseButtons[0].txtCaption.fontSize;

        imgPauseDrawOff.width = pauseButtons[0].width * 1.2;
        imgPauseDrawOff.scale.y = imgPauseDrawOff.scale.x;
        imgPauseDrawOff.position.setTo((game.width >> 1), posY);

        imgPauseDraw1.visible = GameData.profile.Draw1;
        imgPauseDraw3.visible = !imgPauseDraw1.visible;

        grpPauseLeftDraw.position.set(imgPauseDrawOff.position.x - (imgPauseDraw1.width * 0.55), imgPauseDrawOff.position.y)
        grpPauseLeftDraw.children[1].fontSize = pauseButtons[0].txtCaption.fontSize;
        updateScaleByWidth(grpPauseLeftDraw, imgPauseDraw1.width * 0.5);

        grpPauseRightDraw.position.set(imgPauseDrawOff.position.x + (imgPauseDraw3.width * 0.1), imgPauseDrawOff.position.y)
        grpPauseRightDraw.children[1].fontSize = pauseButtons[0].txtCaption.fontSize;
        updateScaleByWidth(grpPauseRightDraw, imgPauseDraw3.width * 0.5);

        var scale = Math.min(grpPauseLeftDraw.scale.x, grpPauseRightDraw.scale.x, grpPauseLeftDraw.scale.y, grpPauseRightDraw.scale.y)
        grpPauseLeftDraw.scale.set(scale);
        grpPauseRightDraw.scale.set(scale);

        if (imgPauseDraw1.visible) {
            grpPauseLeftDraw.children[0].tint = 0x000000;
            grpPauseLeftDraw.children[1].tint = 0x000000;
            grpPauseRightDraw.children[0].tint = 0xB8B8B8;
            grpPauseRightDraw.children[1].tint = 0xB8B8B8;
        } else {
            grpPauseRightDraw.children[0].tint = 0x000000;
            grpPauseRightDraw.children[1].tint = 0x000000;
            grpPauseLeftDraw.children[0].tint = 0xB8B8B8;
            grpPauseLeftDraw.children[1].tint = 0xB8B8B8;
        }
    },

    update: function () {
    },

    updateTexts: function () {
        for (var i = 0; i < pauseButtons.length; i++) {
            pauseButtons[i].txtCaption.text = STR(pauseButtons[i].STR);
        }

        // imgPauseDrawOff.txtCaption1.text = STR('DRAW_1');
        // imgPauseDrawOff.txtCaption2.text = STR('DRAW_3');
    },

    ShowAnimated: function () {
        ScenePause.instance.onResolutionChange();

        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
        ScenesTransitions.showSceneAlpha(grpScenePause, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_IN = Phaser.Easing.Linear.In;
    },

    HideAnimated: function () {
        ScenesTransitions.transitionStarted();
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
        ScenesTransitions.hideSceneAlpha(grpScenePause, 0, ScenesTransitions.TRANSITION_LENGTH, ScenesTransitions.transitionFinished);
        ScenesTransitions.TRANSITION_EFFECT_OUT = Phaser.Easing.Linear.Out;
    }

}