
var resolutionY_min = 950;
var resolutionY_max = 2300;
var resolutionX = 680;
var resolutionY = resolutionY_max;

var languageLoaded = false;
var isIOS = false;

var userAgent = navigator.userAgent || navigator.vendor || window.opera;
if( userAgent.match( /iPad/i ) || userAgent.match( /iPhone/i ) || userAgent.match( /iPod/i ) )
    isIOS = true;

var aspect = window.innerWidth / window.innerHeight;
// resolutionY = resolutionX / aspect;

console.log("[" + window.innerWidth + ", " + window.innerHeight + "] " + aspect);
var androidVersionString = getAndroidVersion();
var androidVersionMajor = 4;
if(androidVersionString != false)
    androidVersionMajor = parseInt(getAndroidVersion(), 10);

var GAME_FONT = 'gameFont';
if(androidVersionMajor < 4)
    GAME_FONT = 'arial'

var chromeVersion = null;
var bdBrowser = null;
var selectedRenderer = null;
var defaultBrowser40 = null; // this is true on android 4.3, default browser - renderer is CANVAS, and only mp3 files are loaded

try {
    chromeVersion = parseInt(window.navigator.appVersion.match(/Chrome\/(\d+)\./)[1], 10);
} catch (e) {
}

selectedRenderer = Phaser.WEBGL;

try {
    bdBrowser = window.navigator.appVersion.indexOf("bdbrowser") > -1;
    defaultBrowser40 = window.navigator.appVersion.indexOf("Version/4.0") > -1;
} catch (e) {
}

if (!Phaser.Device.desktop && ((bdBrowser != null && bdBrowser == true) || (defaultBrowser40 != null && defaultBrowser40 == true))) // problem s maskami pri renderovani cez webgl v baidubrowser, preto sa zvoli canvas
    selectedRenderer = Phaser.CANVAS;

selectedRenderer = Phaser.AUTO;

    selectedRenderer = Phaser.CANVAS;

var config = {
    width: resolutionX,
    height: resolutionY,
    renderer: selectedRenderer,
    enableDebug: false,
    antialias: true,
    forceSetTimeOut: false
}

window.addEventListener("contextmenu", function(e) { e.preventDefault();});
window.addEventListener("touchend", function() {
    if (game === null) return;
    try { // na ios neexistuje .state, preto to je v try-catch
        if (game.sound.context.state !== 'running') {
            game.sound.context.resume();
        }
    } catch (err) {}
}, false);

if (!RUNNING_ON_IOS) {
    document.addEventListener("touchstart", function (e) {e.preventDefault();});
    document.addEventListener("touchmove", function (e) {e.preventDefault();});
}

//aby sa nezobrazoval scroll
document.documentElement.style.overflow = 'hidden';  // firefox, chrome
document.body.scroll = "no"; // ie only

var game;

function phaserInit() {
    game = new Phaser.Game(config);
//var game = new Phaser.Game(resolutionX, resolutionY, selectedRenderer, '');
//game.preserveDrawingBuffer = true;
    game.forceSingleUpdate = true;

    game.state.add("SplashState", Splash);
    game.state.add("PreloadState", Preloader);
    game.state.add("GameState", GameState);

    game.state.start("SplashState");
}

//PPS_DELETE-SPILGAMES
phaserInit();
//PPS_DELETE-SPILGAMES

adinplay_init();

function isPortrait() {

    switch (window.orientation) {
        case 0:
        case 180:
            return true;
    }
    return false;
}

//PPS_USE-DEMO_VERSION
/*
document.title = GameData.BuildTitle + " - DEMO";
//PPS_USE-DEMO_VERSION
*/

//PPS_USE-INLOGICcampaigns
/*
var cmpgn_game_id = 419;
window['cgi'] = cmpgn_game_id;
var cmpgn_partner_id = null;
window['cpi'] = cmpgn_partner_id;
//PPS_USE-INLOGICcampaigns
*/

//PPS_USE-INLOGICleaderboard
/*
if(typeof INLOGIC_LEADERBOARD !== "undefined") {INLOGIC_LEADERBOARD.init("SolitaireGrande", ".stlrngrd2018!", "http://html5leaderboards.inlogic.sk");}
//PPS_USE-INLOGICleaderboard
*/

//PPS_USE-WildTangent
/*
// handle incoming messages
function messageHandler(event) {
    if( event.data == "action=pause" ) {
        game.tweens.pauseAll();
        // WildTangent wants to show an ad.
        // Need to pause and mute your game to prepare.

        game.sound.mute = true;
    }
    if( event.data == "action=resume" ) {
        game.tweens.resumeAll();

        game.sound.mute = false;

        // WildTangent ad has completed.
        // Go ahead and resume your game.
    }
}

// set up the listener for incoming messages
if (window.addEventListener) {
    addEventListener("message", messageHandler, false);
} else {
    attachEvent("onmessage", messageHandler);
}
//PPS_USE-WildTangent
*/

//PPS_USE-SDK:iWIN
/*
iConsole.game.ready({
    soundOnOff: true,
    pauseable: true,
    restartable: true
}).result();
//PPS_USE-SDK:iWIN
*/

//PPS_USE-GAME_DISTRIBUTION
/*
window["GD_OPTIONS"] = {
// This is the gameId you get when you've create a game on gamedistribution.com
    "gameId": "19c053953c0a4963ba2cd6ab2be4a109", //TODO
    "onEvent": function(event) {
        switch (event.name) {
            case "SDK_GAME_START":
                // advertisement done, resume game logic and unmute audio
                game.sound.mute = false;
                break;
            case "SDK_GAME_PAUSE":
                // pause game logic / mute audio
                // todo tu nakopirovat to, co sa deje v ongamepause (okrem vypnutia zvuku) - pozor na "this."
                gameRunning = false;
                // soundManager.playSound('menu-click1');
                SceneMenu.instance.onResolutionChange();
                ScenePause.instance.ShowAnimated();
                SceneMenu.instance.ShowAnimated();
                game.sound.mute = true;
                break;
        }
    }
};
(function(d, s, id) {
    var js, fjs = d.getElementsByTagName(s)[0];
    if (d.getElementById(id)) return;
    js = d.createElement(s);
    js.id = id;
    js.src = 'https://html5.api.gamedistribution.com/main.min.js';
    fjs.parentNode.insertBefore(js, fjs);
}(document, 'script', 'gamedistribution-jssdk'));

//PPS_USE-GAME_DISTRIBUTION
*/

//PPS_USE-GRANDTECHNOLOGY
/*
function getJsonFromUrl() {
    var query = location.search.substr(1);
    var result = {};

    var queryList = query.split("&");
    for (var i = 0; i < queryList.length; i++){
        var pos = queryList[i].indexOf("=");
        var item = [queryList[i].substring(0, pos), queryList[i].substring(pos + 1)];
        result[item[0]] = decodeURIComponent(item[1]);
    }

    return result;
}

function createREQ(URL, method, dataToSend, callback) {
    //console.log("data sending", URL, dataToSend);

    var request = new XMLHttpRequest();

    request.onerror = function() {
        callback(dataToSend, {});
    };

    request.onload = function() {
        var result = JSON.parse(request.responseText);
        callback(dataToSend, result);
    };

    if (method == "GET"){
        request.open("GET", URL, true);

        request.send();
    }

    if (method == "POST"){
        request.open("POST", URL, true);
        request.setRequestHeader('Content-Type', 'application/json')

        request.send(JSON.stringify(dataToSend));
    }
}

var playIT_header = getJsonFromUrl();
var playIT_APIkey = "5ECBA58BEF6B7";
var playIT_userData = null;



function getPlayItData(callback) {
    createREQ("http://www.api.playit.mobi/api/v1/backend/getuserdata/" + playIT_APIkey + "/" + playIT_header['game_id'] + "/" + playIT_header['user_id'], "GET", null, function (sendData, res) {
        console.log('loaded data:', res);
        if (res != undefined){
            //res = JSON.parse(res);
            if (res['status'] == true){
                if (res['user'] != null)
                    if (res['user']['game_profile'] != null)
                        playIT_userData = res['user']['game_profile'];

                callback(true);
            } else {
                callback(false, res['message']);
            }
        }
    });
}

function savePlayItData(data) {
    var sendObject = {
        "API_Key": playIT_APIkey,
        "game_id": playIT_header['game_id'],
        "user_id": playIT_header['user_id'],
        "new_profile": data
    };

    createREQ("http://www.api.playit.mobi/api/v1/backend/saveprofile", "POST", sendObject, function (data, res) {
        console.log('save data', res)
    });
}

function getPlayITsavedDataVar(param) {
    if (playIT_userData == undefined) return null;

    return playIT_userData[param];
}
//PPS_USE-GRANDTECHNOLOGY
*/

//PPS_USE-CLOUDGAMES
/*
function cloudGames_moregames_link() {
    if (CloudAPI.links.active()) {
        window.open(CloudAPI.links.list()['games']);
    }
}

function cloudGames_logo_link() {
    if (CloudAPI.links.active()) {
        window.open(CloudAPI.links.list()['logo']);
    }
}
//PPS_USE-CLOUDGAMES
*/

//PPS_USE-YANDEX
/*
function showYandexAd () {
}

YaGames
    .init()
    .then(ysdk => {
    showYandexAd = function () {
        if (showYandexAd.lastAdTime !== 'nan'){
            var rozdiel = Date.now() - showYandexAd.lastAdTime;
            if (rozdiel < 60000) return;
        }

        showYandexAd.lastAdTime = Date.now();
        ysdk.adv.showFullscreenAdv({
            callbacks: {
                onOpen: function() {
                    game.sound.mute = true;
                },
                onClose: function(wasShown) {
                    console.log('onClose', wasShown);
                    game.sound.mute = false;
                },
                onError: function(error) {
                    console.log('onError', error);
                    game.sound.mute = false;
                }
            }
        });
    };

showYandexAd.lastAdTime = 'nan';
});
//PPS_USE-YANDEX
*/

//PPS_USE-SPILGAMES
/*
var spilApiInstance;
var SpilData = {
    id: '576742227280306174' // Replace with the value you receive from Spil Games
};

<!-- Initialise the Spil HTML5 API -->
GameAPI.loadAPI (function (apiInstance) {
    spilApiInstance = apiInstance;

    // The API is ready for use.
    if (window.console && window.console.log) {
        console.log('GameAPI version ' + apiInstance.version + ' loaded!');
    }

    phaserInit();
}, SpilData);

function pauseGame() {
    game.sound.mute = true;
}

function resumeGame(data) {
    game.sound.mute = false;
}
//PPS_USE-SPILGAMES
*/

//PPS_USE-DISTRIBUTE_GAMES
/*
window["SDK_OPTIONS"] = {
    gameId: "94f8lgrijld69pzsn9hoy1wryllzemsn",
    onEvent: function (a) {
        switch (a.name) {
            case "SDK_GAME_START":
                // advertisement done, resume game logic and unmute audio
                if (game != null) {
                    game.sound.mute = false;
                    game.paused = false;
                }
                break;
            case "SDK_GAME_PAUSE":
                // pause game logic / mute audio
                gameRunning = false;
                // soundManager.playSound('menu-click1');
                SceneMenu.instance.onResolutionChange();
                ScenePause.instance.ShowAnimated();
                SceneMenu.instance.ShowAnimated();

                if (game != null) {
                    game.sound.mute = true;
                }

                break;
            case "SDK_READY":
                // when sdk is ready
                break;
        }
    }
};
(function (a, b, c) {
    var d = a.getElementsByTagName(b)[0];
    a.getElementById(c) || (a = a.createElement(b), a.id = c, a.src = "https://api.gamemonetize.com/sdk.js", d.parentNode.insertBefore(a, d))
})(document, "script", "gamemonetize-sdk");
//PPS_USE-DISTRIBUTE_GAMES
// */

//-RPLC:MAIN_FILE_END-//